//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red


extern int RSIPeriod=8;
extern int MA_periods = 8;
extern int SignalGap = 10;


double CrossUp[];
double CrossDown[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexStyle(0, DRAW_ARROW, 0, 2); 
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, 0, 2);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i;   
   
   int counted_bars=IndicatorCounted();

//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
      
   
   double RSI[];
   double RSI_MA[];   
   ArrayResize(RSI,limit);
   ArrayResize(RSI_MA,limit);   
   ArraySetAsSeries(RSI,true);
   
   for( i=Bars-50; i>=0; i--){
     RSI[i]=iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,i);
     RSI_MA[i]=iMAOnArray(RSI,0,MA_periods,0,MODE_SMA,i);
     double RSI1 =RSI[1];
     double RSI2 =RSI[2];     
     double RSI_MA1 =RSI_MA[1];
     double RSI_MA2 =RSI_MA[2];     

       
      if (RSI2<RSI_MA2 && RSI1>RSI_MA1 && RSI1<50)
         CrossUp[i] = Low[i] - SignalGap*Point;
  
      if (RSI2>RSI_MA2 && RSI1<RSI_MA1 && RSI1>50)
         CrossDown[i] = High[i] + SignalGap*Point;
      }
   
   return(0);
}

